## mingw-w64-bpmdetect-0.8.9-1.src.tar.zst

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.31)
project(
  bpmdetect
  LANGUAGES C CXX
  VERSION 0.8.9
  DESCRIPTION "Automatic BPM detection tool"
  HOMEPAGE_URL "https://github.com/Tatsh/bpmdetect")

include(FeatureSummary)
include(FindPkgConfig)
include(GNUInstallDirs)

set(CMAKE_AUTOMOC ON)
set(CMAKE_AUTORCC ON)
set(CMAKE_AUTOUIC ON)

set(CMAKE_CXX_STANDARD 23)
set(CMAKE_CXX_EXTENSIONS OFF)
set(CMAKE_CXX_STANDARD_REQUIRED ON)

option(BPMDETECT_CXX_WARN_ALL "Do not use." OFF)
mark_as_advanced(BPMDETECT_CXX_WARN_ALL)
option(BUILD_DOCS "Build documentation." OFF)
option(BUILD_DOCS_ONLY "Build documentation only." OFF)
option(BUILD_TESTS "Build tests." OFF)
option(COVERAGE "Enable code coverage." OFF)
option(NON_PORTABLE_MACOS_BUNDLE
       "Create a macOS bundle which will depend on libraries within FHS-compliant directories \
(Homebrew, MacPorts). Implies FHS=ON." OFF)
option(NO_GUI "Build CLI-only version.")
set(BUNDLE_INSTALL_PREFIX
    .
    CACHE FILEPATH "Install the bundle to a custom directory. This can be an absolute path or \
relative to CMAKE_INSTALL_PREFIX.")
option(I18N "Enable i18n support." OFF)
option(ENABLE_DESKTOP_PORTAL "Build with support for desktop portal (Flatpak)." OFF)

if(NOT APPLE)
  set(NON_PORTABLE_MACOS_BUNDLE
      OFF
      CACHE BOOL "Non-portable macOS bundle mode." FORCE)
endif()
if(APPLE)
  if(NON_PORTABLE_MACOS_BUNDLE)
    set(FHS
        ON
        CACHE BOOL "Use FHS directories." FORCE)
  else()
    set(EXTRA_DOCS
        ON
        CACHE BOOL "Install extra documentation.")
  endif()
endif()
if(CMAKE_SYSTEM_NAME MATCHES "Linux|MSYS|CYGWIN|FreeBSD|NetBSD|OpenBSD|DragonFly")
  set(FHS
      ON
      CACHE BOOL "Use FHS directories.")
endif()

if(NOT BUILD_DOCS_ONLY)
  find_package(ECM NO_MODULE REQUIRED)
  list(APPEND CMAKE_MODULE_PATH ${ECM_MODULE_PATH})
  include(ECMQtDeclareLoggingCategory)

  find_package(Qt6Core 6.7 CONFIG REQUIRED)
  if(NOT NO_GUI)
    find_package(Qt6Gui 6.7 CONFIG REQUIRED)
    find_package(Qt6LinguistTools 6.7 CONFIG REQUIRED)
    find_package(Qt6Multimedia 6.7 CONFIG REQUIRED)
    find_package(Qt6Widgets 6.7 CONFIG REQUIRED)
  endif()
  qt_standard_project_setup()
  pkg_check_modules(
    FFMPEG
    libavformat
    libavcodec
    libavutil
    REQUIRED
    IMPORTED_TARGET
    GLOBAL)
  pkg_check_modules(SOUNDTOUCH soundtouch REQUIRED IMPORTED_TARGET GLOBAL)

  feature_summary(WHAT ALL FATAL_ON_MISSING_REQUIRED_PACKAGES)

  # Sane flags from Kate
  add_compile_definitions(
    QT_NO_CAST_FROM_ASCII
    QT_NO_CAST_FROM_BYTEARRAY
    QT_NO_CAST_TO_ASCII
    QT_NO_SIGNALS_SLOTS_KEYWORDS
    QT_NO_URL_CAST_FROM_STRING
    QT_STRICT_ITERATORS
    QT_USE_FAST_OPERATOR_PLUS
    QT_USE_QSTRINGBUILDER
    $<$<BOOL:${NO_GUI}>:NO_GUI>)
  add_compile_options($<$<AND:$<CXX_COMPILER_ID:Clang,GNU>,$<BOOL:${COVERAGE}>>:--coverage>)
  add_link_options($<$<AND:$<CXX_COMPILER_ID:Clang,GNU>,$<BOOL:${COVERAGE}>>:--coverage>)

  if(CMAKE_BUILD_TYPE STREQUAL "Debug")
    if(CMAKE_CXX_COMPILER_ID STREQUAL "Clang" AND BPMDETECT_CXX_WARN_ALL)
      add_compile_options(
        -fsafe-buffer-usage-suggestions
        -Weverything
        -Wno-c++98-compat
        -Wno-c++98-compat-pedantic
        -Wno-exit-time-destructors
        -Wno-global-constructors
        -Wno-padded)
    endif()
  endif()

  add_subdirectory(src)
  if(BUILD_TESTS)
    find_package(Qt6Test CONFIG REQUIRED)
    enable_testing()
    add_subdirectory(tests)
  endif()
endif()

if(BUILD_DOCS OR BUILD_DOCS_ONLY)
  set(DOXYGEN_GENERATE_TAGFILE "${CMAKE_BINARY_DIR}/html/bpmdetect.tags")
  set(DOXYGEN_INTERACTIVE_SVG YES)
  set(DOXYGEN_MARKDOWN_ID_STYLE GITHUB)
  set(DOXYGEN_USE_MDFILE_AS_MAINPAGE "${CMAKE_SOURCE_DIR}/README.md")
  set(DOXYGEN_TAGFILES
      ./.docs/cppreference-doxygen-web.tag.xml=https://en.cppreference.com/w/
      ./.docs/qtcore.tags=http://doc.qt.io/qt-6/
      ./.docs/qtgui.tags=http://doc.qt.io/qt-6/
      ./.docs/qtwidgets.tags=http://doc.qt.io/qt-6/
      ./.docs/soundtouch.tags=https://codeberg.org/soundtouch/soundtouch/)
  find_package(Doxygen REQUIRED COMPONENTS dot)
  doxygen_add_docs(docs README.md src ALL)
endif()

=== src/CMakeLists.txt ===
add_subdirectory(track)
if(NOT NO_GUI)
  add_subdirectory(widgets)
endif()
set(DISPLAY_NAME "BPM Detect")

set(SOURCES
    bpmdetect.qrc
    icons/not-padded/16x16.png
    icons/not-padded/16x16@2x.png
    icons/not-padded/32x32.png
    icons/not-padded/32x32@2x.png
    icons/not-padded/48x48.png
    icons/not-padded/48x48@2x.png
    icons/not-padded/64x64.png
    icons/not-padded/64x64@2x.png
    icons/not-padded/96x96.png
    icons/not-padded/128x128.png
    icons/not-padded/128x128@2x.png
    icons/not-padded/256x256.png
    icons/not-padded/256x256@2x.png
    icons/not-padded/512x512.png
    icons/bpmdetect.icns
    icons/bpmdetect.ico
    consolemain.cpp
    consolemain.h
    debug.cpp
    debug.h
    guimain.cpp
    guimain.h
    ffmpegutils.cpp
    ffmpegutils.h
    main.cpp
    utils.cpp
    utils.h)

ecm_qt_declare_logging_category(
  SOURCES
  HEADER
  debug.h
  IDENTIFIER
  "gLogBpmDetect"
  CATEGORY_NAME
  "sh.tat.${CMAKE_PROJECT_NAME}")

qt_add_executable(bpmdetect WIN32 ${SOURCES})

string(TIMESTAMP YEAR "%Y")
configure_file(sh.tat.${CMAKE_PROJECT_NAME}.metainfo.xml.in
               sh.tat.${CMAKE_PROJECT_NAME}.metainfo.xml @ONLY)

if(WIN32)
  configure_file("version.rc.in" version.rc @ONLY)
  target_sources(bpmdetect PRIVATE version.rc)
  set_source_files_properties(version.rc PROPERTIES COMPILE_DEFINITIONS
                                                    $<$<CONFIG:Release>:NDEBUG=1>)
endif()

target_include_directories(bpmdetect PRIVATE .)
target_link_libraries(bpmdetect PRIVATE PkgConfig::FFMPEG PkgConfig::SOUNDTOUCH Qt6::Core
                                        bpmdetect-track)
if(NOT NO_GUI)
  target_include_directories(bpmdetect PRIVATE widgets)
  target_link_libraries(bpmdetect PRIVATE Qt6::Gui Qt6::Widgets bpmdetect-widgets)
endif()

if(NOT FHS OR NON_PORTABLE_MACOS_BUNDLE) # macOS bundle, non-portable macOS bundle, or plain Windows
                                         # (no MSYS, etc).
  if(APPLE)
    set_target_properties(
      bpmdetect
      PROPERTIES OUTPUT_NAME ${DISPLAY_NAME}
                 MACOSX_BUNDLE TRUE
                 MACOSX_BUNDLE_BUNDLE_NAME ${DISPLAY_NAME}
                 MACOSX_BUNDLE_ICON_FILE "bpmdetect.icns"
                 MACOSX_BUNDLE_BUNDLE_VERSION "${PROJECT_VERSION}"
                 MACOSX_BUNDLE_GUI_IDENTIFIER "sh.tat.${CMAKE_PROJECT_NAME}"
                 MACOSX_BUNDLE_COPYRIGHT "Copyright (c) 2025 ${DISPLAY_NAME} authors."
                 MACOSX_BUNDLE_SHORT_VERSION_STRING "${PROJECT_VERSION}")
    set(deploy_tool_options_arg -hardened-runtime)
    set(executable_path "$<TARGET_FILE_NAME:bpmdetect>.app")
    set(executable_dir ${BUNDLE_INSTALL_PREFIX})
  elseif(WIN32)
    set(deploy_tool_options_arg --no-compiler-runtime)
    set(executable_path "$<TARGET_FILE_NAME:bpmdetect>")
    set(executable_dir "${CMAKE_INSTALL_BINDIR}")
  endif()
  if(NOT NON_PORTABLE_MACOS_BUNDLE OR WIN32)
    qt_generate_deploy_script(
      TARGET
      bpmdetect
      OUTPUT_SCRIPT
      deploy_script
      CONTENT
      [[
    qt_deploy_runtime_dependencies(
    EXECUTABLE "${executable_dir}/${executable_path}"
    DEPLOY_TOOL_OPTIONS ${deploy_tool_options_arg}
    GENERATE_QT_CONF
    VERBOSE)
    ]])
  endif()
  install(TARGETS bpmdetect RUNTIME_DEPENDENCY_SET bpmdetect-deps
          BUNDLE DESTINATION ${BUNDLE_INSTALL_PREFIX})
  if(NOT NON_PORTABLE_MACOS_BUNDLE OR WIN32)
    install(SCRIPT ${deploy_script})
  endif()
  if(APPLE)
    install(
      FILES icons/bpmdetect.icns
      DESTINATION "${BUNDLE_INSTALL_PREFIX}/$<TARGET_FILE_NAME:bpmdetect>.app/Contents/Resources")
  endif()
  if(APPLE AND NOT NON_PORTABLE_MACOS_BUNDLE)
    install(
      FILES ../LICENSE.txt ../README.md ../CHANGELOG.md ../SECURITY.md ../CITATION.cff
      DESTINATION "${BUNDLE_INSTALL_PREFIX}/$<TARGET_FILE_NAME:bpmdetect>.app/Contents/Resources")
  elseif(WIN32)
    install(FILES ../LICENSE.txt ../README.md ../CHANGELOG.md ../SECURITY.md TYPE DOC)
    install(FILES ../CITATION.cff DESTINATION ${CMAKE_INSTALL_DATADIR}/bpmdetect)
    install(FILES ../man/bpmdetect.1 TYPE MAN)
  else()
    install(FILES ../README.md TYPE DOC)
    install(FILES ../man/bpmdetect.1 TYPE MAN)
  endif()
  if(MINGW)
    get_filename_component(_mingw_bin_dir ${CMAKE_C_COMPILER} DIRECTORY)
    install(
      RUNTIME_DEPENDENCY_SET
      bpmdetect-deps
      PRE_EXCLUDE_REGEXES
      [=[api-ms-]=]
      [=[ext-ms-]=]
      [[kernel32\.dll]]
      POST_EXCLUDE_REGEXES
      [=[.*system32\/.*\.dll]=]
      DIRECTORIES
      ${_mingw_bin_dir}
      $<TARGET_FILE_DIR:bpmdetect>)
    install(
      FILES ${_mingw_bin_dir}/libaom.dll
            ${_mingw_bin_dir}/libLerc.dll
            ${_mingw_bin_dir}/libbrotlienc.dll
            ${_mingw_bin_dir}/libdeflate.dll
            ${_mingw_bin_dir}/libgme.dll
            ${_mingw_bin_dir}/libgsm.dll
            ${_mingw_bin_dir}/libhwy.dll
            ${_mingw_bin_dir}/libjxl.dll
            ${_mingw_bin_dir}/libjxl_cms.dll
            ${_mingw_bin_dir}/libjxl_threads.dll
            ${_mingw_bin_dir}/librav1e.dll
            ${_mingw_bin_dir}/libsoxr.dll
            ${_mingw_bin_dir}/libsrt.dll
            ${_mingw_bin_dir}/libssh.dll
            ${_mingw_bin_dir}/libva.dll
            ${_mingw_bin_dir}/libva_win32.dll
            ${_mingw_bin_dir}/xvidcore.dll
      DESTINATION ${CMAKE_INSTALL_BINDIR}
      OPTIONAL)
    install(
      DIRECTORY ${_mingw_bin_dir}
      DESTINATION .
      FILES_MATCHING
      REGEX
        "lib(jbig|datrie|expat|fribidi|gmodule-2.0|jpeg|lcms2|pangoft2-1.0|pangowin32-1.0|sharpyuv|\
thai|tiff|bluray|cairo|cairo-gobject|crypto|dav1d|ffi|fontconfig|gdk_pixbuf-2.0|gio-2.0|\
gmp|gnutls|gobject-2.0|gomp|hogweed|idn2|lc3|lzma|modplug|mp3lame|nettle|opencore-amr[nw]b|\
openjp2|opus|p11-kit|pango-1.0|pangocairo-1.0|pixman-1|rsvg-2|rtmp|speex|SvtAv1Enc|tasn1|\
theora(dec|enc)|unistring|vorbisenc|vpl|vpx|webp|webpmux|x26[45]|xml2|zvbi|lzo2)-.*\.dll")
  endif()
else() # Linux, MSYS package, macOS package without creating a bundle.
  install(TARGETS bpmdetect)
  if(NOT NO_GUI)
    configure_file("${CMAKE_CURRENT_SOURCE_DIR}/${CMAKE_PROJECT_NAME}.desktop.in"
                   "${CMAKE_CURRENT_BINARY_DIR}/sh.tat.${CMAKE_PROJECT_NAME}.desktop" @ONLY)
    install(FILES "${CMAKE_CURRENT_BINARY_DIR}/sh.tat.${CMAKE_PROJECT_NAME}.desktop"
            DESTINATION "${CMAKE_INSTALL_DATAROOTDIR}/applications")
    foreach(
      size
      16
      32
      48
      64
      96
      128
      256
      512)
      install(
        FILES "${CMAKE_CURRENT_SOURCE_DIR}/icons/not-padded/${size}x${size}.png"
        DESTINATION "${CMAKE_INSTALL_DATAROOTDIR}/icons/hicolor/${size}x${size}/apps"
        RENAME sh.tat.${CMAKE_PROJECT_NAME}.png)
    endforeach()
  endif()
  install(FILES ../README.md TYPE DOC)
  install(FILES ../man/bpmdetect.1 DESTINATION ${CMAKE_INSTALL_DATAROOTDIR}/man/man1)
  install(FILES ${CMAKE_CURRENT_BINARY_DIR}/sh.tat.${CMAKE_PROJECT_NAME}.metainfo.xml
          DESTINATION ${CMAKE_INSTALL_DATAROOTDIR}/metainfo)
endif()

if(WIN32)

  configure_file(${CMAKE_CURRENT_SOURCE_DIR}/extra.nsh.in ${CMAKE_BINARY_DIR}/extra.nsh @ONLY)
  string(REPLACE "/" "\\\\" CMAKE_BINARY_DIR_ESCAPED ${CMAKE_BINARY_DIR})
  set(CPACK_NSIS_EXTRA_INSTALL_COMMANDS
      "  !include \\\"${CMAKE_BINARY_DIR_ESCAPED}\\\\extra.nsh\\\"")
  set(CPACK_NSIS_CONTACT "https://bsky.app/profile/tatsh.bsky.social")
  # set(CPACK_NSIS_HELP_LINK ${PROJECT_HOMEPAGE_URL}/issues) # Redundant.
  set(CPACK_NSIS_INSTALLED_ICON_NAME "bin\\\\${CMAKE_PROJECT_NAME}.exe")
  set(CPACK_PACKAGE_EXECUTABLES "${CMAKE_PROJECT_NAME};${DISPLAY_NAME}")
  set(CPACK_CREATE_DESKTOP_LINKS "${CMAKE_PROJECT_NAME};${DISPLAY_NAME}")
  set(CPACK_NSIS_MANIFEST_DPI_AWARE ON)
  set(CPACK_NSIS_DISPLAY_NAME ${DISPLAY_NAME})
  set(CPACK_NSIS_PACKAGE_NAME ${DISPLAY_NAME})
  set(CPACK_NSIS_MODIFY_PATH ON) # Necessary to show the 'Create desktop icon' option,
                                 # unfortunately.
  set(CPACK_NSIS_URL_INFO_ABOUT ${PROJECT_HOMEPAGE_URL}/issues) # Support link in 'Programs and
                                                                # Features'.
  set(CPACK_PACKAGE_INSTALL_DIRECTORY ${DISPLAY_NAME})
  set(CPACK_GENERATOR NSIS ZIP)
elseif(APPLE)
  set(CPACK_GENERATOR DragNDrop ZIP)
else()
  set(CPACK_GENERATOR ZIP)
endif()
set(CPACK_PACKAGE_VENDOR Tatsh)
set(CPACK_RESOURCE_FILE_LICENSE ${CMAKE_SOURCE_DIR}/LICENSE.txt)
set(__cpack_system_name ${CMAKE_SYSTEM_NAME})
if(__cpack_system_name MATCHES "Windows")
  if(CMAKE_SIZEOF_VOID_P EQUAL 8)
    set(__cpack_system_name win64)
  else()
    set(__cpack_system_name win32)
  endif()
elseif(APPLE)
  if(CMAKE_APPLE_SILICON_PROCESSOR)
    set(__cpack_system_name Darwin-arm64)
  else()
    set(__cpack_system_name Darwin-x86_64)
  endif()
endif()
set(CPACK_THREADS 0)
set(CPACK_PACKAGE_FILE_NAME
    ${CMAKE_PROJECT_NAME}-${CMAKE_PROJECT_VERSION}-${__cpack_system_name}-${CMAKE_BUILD_TYPE})
include(CPack)

=== src/track/CMakeLists.txt ===
set(TRACK_SRCS abstractbpmdetector.cpp abstractbpmdetector.h soundtouchbpmdetector.cpp
               soundtouchbpmdetector.h track.cpp track.h)
add_library(bpmdetect-track STATIC ${TRACK_SRCS})
target_include_directories(bpmdetect-track PRIVATE ..)
target_link_libraries(bpmdetect-track PRIVATE PkgConfig::FFMPEG PkgConfig::SOUNDTOUCH Qt6::Core)
target_compile_definitions(
  bpmdetect-track PRIVATE SAMPLE_MAX_VALUE=32768 $<$<BOOL:${ENABLE_DESKTOP_PORTAL}>:DESKTOP_PORTAL>)

=== src/widgets/CMakeLists.txt ===
set(WIDGETS_SRCS
    dlgbpmdetect.cpp
    dlgbpmdetect.h
    dlgbpmdetect.ui
    dlgtestbpm.cpp
    dlgtestbpm.h
    dlgtestbpmdlg.ui
    dlgtestbpmplayer.cpp
    dlgtestbpmplayer.h
    progressbar.cpp
    progressbar.h
    qdroplistview.cpp
    qdroplistview.h
    trackitem.cpp
    trackitem.h
    trackitemdelegate.cpp
    trackitemdelegate.h)
add_library(bpmdetect-widgets STATIC ${WIDGETS_SRCS})
target_include_directories(bpmdetect-widgets PRIVATE ..)
target_link_libraries(bpmdetect-widgets PRIVATE PkgConfig::SOUNDTOUCH Qt6::Core Qt6::Gui
                                                Qt6::Multimedia Qt6::Widgets)
# https://stackoverflow.com/a/60203765/374110
get_property(_isMultiConfig GLOBAL PROPERTY GENERATOR_IS_MULTI_CONFIG)
if(_isMultiConfig)
  set(AUTOGEN_INCLUDE_DIR ${CMAKE_CURRENT_BINARY_DIR}/bpmdetect-widgets_autogen/include_$<CONFIG>)
else()
  set(AUTOGEN_INCLUDE_DIR ${CMAKE_CURRENT_BINARY_DIR}/bpmdetect-widgets_autogen/include)
endif()
target_include_directories(bpmdetect-widgets INTERFACE $<BUILD_INTERFACE:${AUTOGEN_INCLUDE_DIR}>)
target_compile_definitions(bpmdetect-widgets PRIVATE MIGRATE_OLD_SETTINGS)

=== PKGBUILD ===
# Maintainer: Andrew Udvare <audvare@gmail.com>

_realname=bpmdetect
pkgbase=mingw-w64-${_realname}
pkgname=("${MINGW_PACKAGE_PREFIX}-${_realname}")
pkgver=0.8.9
pkgrel=1
pkgdesc="Automatic BPM detection utility."
arch=('any')
mingw_arch=('mingw64' 'ucrt64' 'clang64' 'clangarm64')
url='https://github.com/Tatsh/bpmdetect'
msys2_repository_url='https://github.com/Tatsh/bpmdetect'
msys2_references=(
  "gentoo: media-sound/bpmdetect"
)
license=('spdx:GPL-3.0-or-later')
depends=(
  "${MINGW_PACKAGE_PREFIX}-ffmpeg"
  "${MINGW_PACKAGE_PREFIX}-qt6-base"
  "${MINGW_PACKAGE_PREFIX}-qt6-multimedia"
  "${MINGW_PACKAGE_PREFIX}-soundtouch"
  "${MINGW_PACKAGE_PREFIX}-zlib"
)
makedepends=(
  "${MINGW_PACKAGE_PREFIX}-cc"
  "${MINGW_PACKAGE_PREFIX}-cmake"
  "${MINGW_PACKAGE_PREFIX}-extra-cmake-modules"
  "${MINGW_PACKAGE_PREFIX}-ninja"
  "${MINGW_PACKAGE_PREFIX}-pkgconf"
  "${MINGW_PACKAGE_PREFIX}-qt6-tools"
)
source=("https://github.com/Tatsh/${_realname}/archive/refs/tags/v${pkgver}.tar.gz")
sha256sums=('50432f5d488666dc998e75cbe0ff889d3ef6087c2981c5bcd8090425c6e3a295')

build() {
  MSYS2_ARG_CONV_EXCL="-DCMAKE_INSTALL_PREFIX=" \
    cmake \
      -DCMAKE_BUILD_TYPE=Release \
      -DFHS=ON \
      -G Ninja \
      -DCMAKE_INSTALL_PREFIX="${MINGW_PREFIX}" \
      -S "${_realname}-${pkgver}" \
      -B "build-${MSYSTEM}"

  cmake --build "build-${MSYSTEM}"
}

check() {
  cmake -DBUILD_TESTS=ON -S ../${_realname}-${pkgver} -B "build-${MSYSTEM}" -DCMAKE_BUILD_TYPE=Debug
  cmake --build "build-${MSYSTEM}-Debug" --config Debug
  ctest --test-dir "build-${MSYSTEM}-Debug" --output-on-failure || true
}

package() {
  DESTDIR="${pkgdir}" "${MINGW_PREFIX}/bin/cmake" --install "build-${MSYSTEM}" --config Release
  install -Dm644 "${srcdir}/${_realname}-${pkgver}/LICENSE.txt" \
    "${pkgdir}${MINGW_PREFIX}/share/licenses/${_realname}/LICENSE.txt"
}
